'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill');

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BittrexPublicAPI = function () {
  function BittrexPublicAPI() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : { baseURL: 'https://bittrex.com/api/v1.1' },
        baseURL = _ref.baseURL;

    _classCallCheck(this, BittrexPublicAPI);

    this.api = _axios2.default.create({ baseURL: baseURL });
  }

  _createClass(BittrexPublicAPI, [{
    key: 'getMarkets',
    value: function getMarkets() {
      return getRequest({
        api: this.api,
        path: '/public/getmarkets'
      });
    }
  }, {
    key: 'getCurrencies',
    value: function getCurrencies() {
      return getRequest({
        api: this.api,
        path: '/public/getcurrencies'
      });
    }
  }, {
    key: 'getTicker',
    value: function getTicker(pair) {
      return getRequest({
        api: this.api,
        path: '/public/getticker',
        query: { market: pair }
      });
    }
  }, {
    key: 'getMarketSummaries',
    value: function getMarketSummaries() {
      return getRequest({
        api: this.api,
        path: '/public/getmarketsummaries'
      });
    }
  }, {
    key: 'getMarketSummary',
    value: function getMarketSummary(pair) {
      return getRequest({
        api: this.api,
        path: '/public/getmarketsummary',
        query: { market: pair }
      });
    }
  }, {
    key: 'getOrderBook',
    value: function getOrderBook(pair, type) {
      return getRequest({
        api: this.api,
        path: '/public/getorderbook',
        query: { market: pair, type: type }
      });
    }
  }, {
    key: 'getMarketHistory',
    value: function getMarketHistory(pair) {
      return getRequest({
        api: this.api,
        path: '/public/getmarkethistory',
        query: { market: pair }
      });
    }
  }, {
    key: 'getEndpoint',
    value: function getEndpoint(path) {
      var query = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      return getRequest({
        api: this.api,
        path: path,
        query: query
      });
    }
  }]);

  return BittrexPublicAPI;
}();

/*
 *  Private Function(s)
 * * * * */

exports.default = BittrexPublicAPI;
var getRequest = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2) {
    var api = _ref2.api,
        path = _ref2.path,
        _ref2$query = _ref2.query,
        query = _ref2$query === undefined ? {} : _ref2$query;

    var _ref4, data, response;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return api.get(path + '?' + _querystring2.default.stringify(query));

          case 3:
            _ref4 = _context.sent;
            data = _ref4.data;
            return _context.abrupt('return', {
              success: true,
              result: data.result
            });

          case 8:
            _context.prev = 8;
            _context.t0 = _context['catch'](0);
            response = _context.t0.response;
            return _context.abrupt('return', {
              success: false,
              result: response.data
            });

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[0, 8]]);
  }));

  return function getRequest(_x3) {
    return _ref3.apply(this, arguments);
  };
}();